Version 1.0.0
Des-23-2022
bug fix : -

fitur : - membuat barcode
  - menggunakan excelreader
  - membuat qrcode
  - membuat pdf
  - autoload class

Version 1.0.1
Des-24-2022
bug fix : - lokasi file tidak ditemukan ketika menggunakan href atau src dan diarahkan ke folder assets pada sintax html

fitur : - tidak bisa mengakses file secara langsung dari url

Version 1.0.2
Des-26-2022
bug fix : -

fitur : - menggunakan nama class yang sama, tetapi pada folder berbeda

Version 1.0.3
Des-27-2022
bug fix : -

fitur : - update framework automatis sesuai dengan versi terbaru, folder dan file yang terdownload adalah folder bawaan dari framework ini

Version 1.0.4
Des-29-2022
bug fix : - url "not found" ketika menggunakan 4 parameter pada url, contoh : https://domain.com/param_1/param_2/param_3/param_4
          - class database dan class awal tidak ikut terdownload ketika pertama mendownload framework        

fitur : -

Versi 1.0.5
Jan-13-2023
bug fix : - tidak dapat membedakan protocol BASEURL ketika website online tetapi menggunakan http

fitur : - pengaturan database terdapat pada file " pengaturan.php "
        - dapat membedakan pengaturan database online dan offline
        - autoupdate dipindah ke dalam file pengaturan.php
        - untuk penggunaan online, tidak perlu mengatur nilai dari variable $_PENGATURAN['ROOR_DIR']

Versi 1.0.6
Jan-15-2023
bug fix : - setelah dilakukan update, file bawaan saat mendownload pertama kali, masih terikut

fitur : - update automatis ketika versi dari developer berubah
        
Versi 1.0.7
Feb-19-2023
bug fix : - parameter ke #2 dan #3 pada url tidak bisa menggunakan angka dan huruf, atau gabungan dari keduanya
            contoh : https://domain.com/param_1/param_2/param_3/param_4
            
fitur : - tidak mengizinkan mengambil isi content html menggunakan file_get_contents dari php
        - menambahkan keamanan untuk request cross domain, pada file keamanan.php
        
Versi 1.0.8
Mar-02-2023
bug fix : - tidak dapat menampilkan file error 404 ketika url tidak ditemukan

fitur : - membuat list request yang akan diamankan ketika request cross domain
        - menambahkan custom message untuk request cross domain yang diamankan
        
Versi 1.0.9
Mar-09-2023
bug fix : - ketika pindah halaman selalu ada slash pada akhir url

fitur : - mengoptimalkan ukuran transfer html file dengan menghilangkan komentar dari html
        - menambahkan pilihan slash atau tidak ketika menggunakan $this->view->pindah($url, $slash);
          nilai default $slash : true
          contoh :
                  - ketika tidak ingin ada slash pada akhir url, gunakan  $this->view->pindah('url/yang_dituju', false);

Versi 1.1.0
Mar-15-2023
bug fix : - tidak bisa menjalankan javascript ketika javascript di komentar

fitur : -

Versi 1.1.1
Mar-16-2023
bug fix : -

fitur : - mengambil isi file view sebagai text

Versi 1.1.2
Mar-22-2023
bug fix : -

fitur : - menambahkan template engine untuk memudahkan pengaturan file

Versi 1.1.3
Mar-22-2023
bug fix : - tidak bisa menampilkan halaman ketika menggunakan fungsi view->show('nama_file');
          
fitur : -

Versi 1.1.4
Mar-23-2023
bug fix : - tidak dapat mengoptimalkan ukuran transfer file dari versi 1.0.9

fitur : -

Versi 1.1.5
Mar-30-2023
Bug fix : - tidak dapat mengoptimalkan besaran ukuran transfer file ketika menggunakan template
          - akses tidak diizinkan ketika menggunakan ip versi 6 pada $_PENGATURAN['SECURE_CROSS']

fitur : - validasi ip versi 4 dan ip versi 6 ketika mengakses web

Versi 1.1.6
Apr-25-2023
bug fix : - 

fitur : - membuat koneksi ke lebih dari 1 database

Versi 1.1.7
Mei-12-2023
bug fix : - untuk php versi 8.2 keatas, aktifkan extension "php_zip.dll" pada file "php.ini" untuk menggunakan class ZipArchive dari php

fitur : -

Version 1.1.8
Jun-4-2023
bug fix : - tidak dapat mengextract Zip update file

fitur : - menambahkan beberapa fungsi untuk class mysql

Version 1.1.9
Jun-5-2023
bug fix : -

fitur : - menambahkan file " memory_usage " untuk monitoring penggunaan RAM ketika mengakses website

Version 1.2.0
Jun-8-2023
bug fix : - tidak bisa akses ke subfolder untuk folder assets/css | assets/js | assets/img 

fitur : - 

Version 1.2.1
Jun-21-2023
bug fix : - tidak dapat mengekstrak file update ketika selesai terdownload updatean terbaru

fitur : -

Versi 1.2.2
Jun-23-2023
bug fix : -

fitur : - menghilangkan komentar dari html dan javascript ketika ditampilkan

Versi 1.2.3
Jun-25-2023
bug fix : -

fitur : - mengarahkan semua request/permintaan ke file index.php

Versi 1.2.4
Jun-26-2023
bug fix : -

fitur : - menambahkan fitur untuk simulasi halaman / tampilan.
         - file simulasi_url akan dibuat ketika file tersebut tidak ada
         - dokumentasi terkait fitur simulasi halaman berada pada file simulasi_url
         
Versi 1.2.5
Jun-29-2023
bug fix : - file assets dalam folder font | QrData yang tidak dapat diakses
          - tidak dapat mengakses subfolder dalam assets ketika subfolder lebih dari 1
fitur : -

Versi 1.2.6
Jul-11-2023
bug fix : - file asset css, js, dan img tidak ditemukan ketika menggunakan simulasi_url

fitur : -

Versi 1.2.7
Jul-31-2023
bug fix : - memperbaiki path untuk pengambilan assets ketika ingin menggunakan folder tersendiri

fitur : - menambahkan file cache untuk halaman yang akan ditampilkan
        - menambahkan $_PENGATURAN['ALLOWED_ASSETS'] = ['css', 'js', 'img', 'font', 'doc', 'QrData'];
          pada bagian akhir dari file pengaturan.php

Versi 1.2.8
Agu-03-2023
bug fix : -

fitur : - bisa upload file dari local ke domain online sesuai dengan domain yang di tulis
          pada .online_update
        - untuk lebih jelasnya lihat dokumentasi pada file .online_update

Versi 1.2.9
Agu-04-2023
bug fix : - tidak dapat mengupload file menggunakan .online_update jika file tersebut 
            lebih dari 1

fitur : - 

Versi 1.3.0
Agu-05-2023
bug fix : -

fitur : - bisa download file dari domain online ke local menggunakan .online_update

Versi 1.3.1
Sep-03-2023
bug fix : - tidak dapat menghilangkan comment ketika comment html lebih dari 1 baris.

fitur : - 

Versi 1.3.2
Nov-12-2023
bug fix : - mencari class pada folder umum terlebih dahulu, setelah itu cari pada folder dalam classes
          - tidak dapat mengupdate semua file ketika menggunakan .online_update
          - tidak dapat mengambil asset ketika menggunakan simulasi_url
          - tidak dapat mendownload file menggunakan .online_update
          
fitur : -

Versi 1.3.3
Nov-14-2023
bug fix : - memperbaiki beberapa kesalahan penulisan

fitur : -

Versi 1.3.4
Nov-23-2023
bug fix : - mengurangi ukuran transfer halaman html
          - memperbaiki request auto update yang berulang dalam 1x reload

fitur : - meningkatkan keamanan terhadap tools mirroring website
        - meningkatkan versi fontawesome

Versi 1.3.5
Des-23-2023
bug fix : - string berubah ketika menggunakan mysql->query
          - tidak bisa mengirim ketika berada pada domain lain
          - error pada _autoloader.class.php baris 16
          - BASEURL tidak diketahui ketika menggunakan port selain 80
          - menghapus fitur download dari online

fitur : - mengganti fontawesome versi lama menjadi fontawesome.6.4.2.css
        - pada versi 1.3.4 kebawah, tambahkan $_PENGATURAN['MODE'] untuk mengatur mode dari framework
          dan $_PENGATURAN['CROS_URL'] untuk menambahkan daftar dari url yang dapat diakses dari domain lain
        - nilai yang dapat digunakan pada $_PENGATURAN['MODE'] adalah developer | production
        - nilai pada $_PENGATURAN['CROS_URL'] harus berupa array 1 level dengan tanpa menggunakan index
          contoh :
                   - $_PENGATURAN['CROS_URL'] = ['admin/dashboard', 'tes/dashboard/lihat'];
        - untuk url pada $_PENGATURAN['CROS_URL'] mengambil nilai setelah BASEURL
          contoh :
                   - https://domain.com/admin/dashboard
                     maka "admin/dashboard" yang akan dianggap sebagai target CROS_URL
                   - https://domain.com/tes/dashboard/lihat
                     maka "tes/dashboard/lihat" yang akan dianggap sebagai target CROS_URL
        - nilai yang dapat digunakan pada $_PENGATURAN['MODE'] adalah 'd', 'p', 'development', 'production'
        - ketika $_PENGATURAN['MODE'] = 'd' atau $_PENGATURAN['MODE'] = 'development' maka error tidak 
          ditampilkan sebagai output dari proses yang error
        - membuat QR Code bisa dimasukan icon pada tengah-tengah QR Code
          untuk lebih jelasnya, lihat pada file sample.class.php bagian QR Code
        - menambahkan fungsi backup database
          untuk lebih jelasnya, lihat pada file sample.class.php bagian backup database

Versi 1.3.6
Des-25-2023
bug fix : - too many connection in mysqli (Koneksi mysqli terlalu banyak)

fitur : - membuat fungsi statik untuk mengambil koneksi database berdasarkan $_PENGATURAN['DB']
        - fungsi statik tersebut adalah :
          - $this->database->getMysqli($koneksi_ke);
          - $this->database->getPdo($koneksi_ke);
        - contoh penggunaan mysqli:
          - $koneksi_ke = 0;
          - $con = $this->database->getMysqli($koneksi_ke);
          - $mysqli = $this->mysqli->setCon($con);
          untuk lebih jelasnya, lihat pada file sample.class.php bagian database lebih dari 1

Versi 1.3.7
Des-31-2023
bug fix : - loading yang lama ketika mengakses file core, yang seharusnya tidak bisa diakses
          - error fungsi simpan pada mysqli kurang jelas
          - tidak bisa mengambil koneksi mysqli menggunakan class mysqli
          
fitur : - memindahkan folder core ke 1 level dengan folder assets, page, error
        - menambahkan fungsi getCon pada mysqli
        - contoh :
          - $con = $this->mysqli->getCon();

Versi 1.3.8
Jan-14-2024
bug fix : - ukuran download masih terlalu besar

fitur : - menambahkan fungsi $this->database->conSize(); untuk mengambil jumlah koneksi yang
          digunakan
        - membuat log error lokal dengan nama file 'snd_log' yang berisi error dari code 
          yang dibuat
        - untuk mendownload framework dengan versi minimalis, bisa menggunakan link | url
          https://frameworks.aliensgroup.my.id/api/downloads/min
        - file yang dikeluarkan ketika menggunakan link | url 
          https://frameworks.aliensgroup.my.id/api/downloads/min :
          - assets/font/fa-brands-400.ttf
          - assets/font/fa-brands-400.woff2
          - assets/font/fa-duotone-900.ttf
          - assets/font/fa-duotone-900.woff2
          - assets/font/fa-light-300.ttf
          - assets/font/fa-light-300.woff2
          - assets/font/fa-regular-400.ttf
          - assets/font/fa-regular-400.woff2
          - assets/font/fa-sharp-light-300.ttf
          - assets/font/fa-sharp-light-300.woff2
          - assets/font/fa-solid-900.ttf
          - assets/font/fa-solid-900.woff2
          - assets/font/fa-thin-100.ttf
          - assets/font/fa-thin-100.woff2
          - assets/font/fa-v4compatibility.ttf
          - assets/font/fa-v4compatibility.woff2
          - assets/font/Arial.ttf
          - assets/font/opensans.ttf

          - assets/css/fontawesome.6.4.2.css
          - assets/css/sb-admin-2.css
          - assets/css/login/sb-admin-2.css
          - assets/js/sb-admin-2.js
          - assets/img/logo.png
          
          - core/barcode.class.php
          - core/customEncrypt.class.php
          - core/excelreader.class.php
          - core/facedetection.class.php
          - core/fpdf.class.php
          - core/htmltodoc.class.php
          - core/oleread.class.php
          - core/qrcode.class.php

          - page/dashboard/a.view.php
          - page/dashboard/main.view.php
          - page/dashboard/tes.view.php
          - page/templates/main.view.php
          - page/templates/sidebar.view.php

Versi 1.3.9
Jun-24-2024
bug fix : - tidak bisa mengakses ketika root folder menggunakan huruf besar | camel case
          - koneksi database terlalu banyak
          - mengambil semua class dalam satu folder classes, bahkan ketika class tersebut
            tidak dibutuhkan
          - memperbaiki class _autoloader
fitur : - menghapus variable $_PENGATURAN['CROS_URL']
        - memudahkan pengelompokan query database dengan cara membuat file bedasarkan
          tabel pada koneksi database
        - setiap tabel yang dibuat, tersimpan dalam folder 'table' dan terurut berdasarkan
          urutan koneksi yang dihitung mulai dari 0

Versi 1.4.0
Agu-27-2024
bug fix : - memperbaiki class excelreader. ketika kolom berisi tanggal tetapi menggunakan format 
            text, tetap terbaca sebagai tanggal
          - memperbaiki class mysql.

fitur : - menambahkan variable $this->mysql::$lastId untuk mengambil id terakhir yang terinput
        - menambahkan fungsi 'dc' & 'dcd' yang berfungsi untuk debug
        - menambahkan fungsi 'setTable' pada class mysql

Versi 1.4.1
Feb-07-2025
bug fix : - 

fitur : - menambahkan custom port untuk koneksi mysql.

Versi 1.4.2
Feb-26-2025
bug fix : - memperbaiki kompatibel core dengan pengaturan dari versi sebelumnya

fitur : - menambahkan variable $_PENGATURAN['TABLE_CLASS']. atur nilai menjadi 'true' 
          untuk menggunakan $this->mysql->table('tabel');
        - mengganti nama folder 'assets' menjadi 'asets'

Versi 1.4.3
Mar-03-2025
bug fix : -

fitur : - menambahkan download online berdasarkan link yang diatur pada file .online_update

Versi 1.4.4
Nov-09-2025
bug fix : - membuat aturan pada file .htaccess untuk tidak memproses . (dot) file
          - memperbaiki aturan pada .htaccess supaya request mengarah ke index.php
          - memperbaiki mysql ketika menyimpan nilai NULL

fitur : -

Versi 1.4.5
Nov-24-2025
bug fix : - memperbaiki online download yang tidak dapat membuat folder baru

fitur : -

Versi 1.4.6
Mei-29-2026
bug fix : - menghilangkan CURLOPT_BINARYTRANSFER yang telah diabaikan oleh php

fitur : - penggunaan fungsi table pada mysql bisa langsung nama tabel jika menggunakan
          $_PENGATURAN['TABLE_CLASS'] = true;
          contoh : $this->mysql->nama_tabel->fungsi();